﻿using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using System;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;

namespace UltraTreeNodeButton
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraTree1.CreationFilter = new ButtonCreationFilter();
        }
    }

    public class ButtonCreationFilter : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is TreeNodeUIElement)
            {
                var preNodeAreaUIElement = parent.ChildElements.OfType<PreNodeAreaUIElement>().FirstOrDefault();
                var nodeSelectableAreaUIElement = parent.ChildElements.OfType<NodeSelectableAreaUIElement>().FirstOrDefault();

                if (preNodeAreaUIElement == null || nodeSelectableAreaUIElement == null) return;

                ButtonUIElement elementToAdd = new ButtonUIElement(parent);
                elementToAdd.Text = "Btn";
                elementToAdd.TextVAlign = VAlign.Top;

                elementToAdd.ElementClick += ElementToAdd_ElementClick;

                int btnWidth = 30;
                int btnHeight = 25;

                elementToAdd.Rect = new System.Drawing.Rectangle(
                        nodeSelectableAreaUIElement.Rect.Left, 
                        nodeSelectableAreaUIElement.Rect.Top-1,
                        btnWidth, 
                        btnHeight
               );

                parent.Rect = new Rectangle(parent.Rect.Location, new Size(parent.Rect.Width + btnWidth, parent.Rect.Height));
                nodeSelectableAreaUIElement.Offset(btnWidth, 0, true);
                parent.ChildElements.Add(elementToAdd);

            }
        }

        private void ElementToAdd_ElementClick(object sender, UIElementEventArgs e)
        {
            UltraTreeNode utn = e.Element.GetContext(typeof(UltraTreeNode)) as UltraTreeNode;
            MessageBox.Show("Clicked on " + utn.Text);        
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
